PGOBLIN_BANG(-f)
  Copyright (C)2022 @BABOLO http://www.babolo.ru/
  pkg = cipalite
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: sess.pgoblin.m4,v 1.1 2022/10/29 03:11:57 babolo Exp $

#echo    Q
##Q copy E
#style   00Q00Q
Q
#connect 0001
sqlite3 :memory:
GETARG(, 1, _)
#select  a001
SELECT a FROM a WHERE i == 0 AND regexp('^[-0-9a-zA-Z_]+$', a) LIMIT 1;
#select  _0a1
SELECT 'sqlite3 WWWROOT/' || ?1 || '/var/www/' || ?1 || '.sqlite'
#connect 0_02
#close   _0_
#perform 00a2
ATTACH 'WWWROOT/' || ?1 || '/var/www/' || ?1 || '.sess.sqlite' AS DBsess;
#perform 0002
PRAGMA temp_store = 2;
#perform 0002
PRAGMA foreign_keys = 1;
#perform 0002
PRAGMA synchronous = 1;
#perform 0002
PRAGMA busy_timeout = 12000;
#select  t0a2
SELECT gettimeofday() - 50, ?;
#begin   0002  ########################################################################################
#perform 00t2
CREATE TEMP TABLE d AS
 SELECT SQNM(sess).SQAT(sess)
  FROM  SQNM(cipaconf)
     ,  SQNM(sess) JOIN SQNM(pass) USING(SQAT(cred))
  WHERE SQNM(pass).SQAT(context) == ?2
    AND SQNM(sess).SQAT(updated) < (CAST(?1 AS real) - COALESCE( SQNM(pass).SQAT(ttl)
                                                               , SQNM(sess).SQAT(ttl)
                                                               , SQNM(cipaconf).SQAT(ttl)
                                   )                           )
;
#perform 0002
DELETE FROM d WHERE SQAT(sess) == (SELECT MAX(SQNM(sess).SQAT(sess)) AS m FROM SQNM(sess));
#select  _0t2
DELETE FROM SQNM(sess)
 WHERE SQAT(sess) IN(SELECT d.SQAT(sess) FROM d)
RETURNING *, ?1
;
#perform 00_2
INSERT INTO SQNM(sessb) VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);
#end     0002  ########################################################################################
