PGOBLIN_BANG(-f)
  Copyright (C)2022 @BABOLO http://www.babolo.ru/
  pkg = cipalite
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: done.pgoblin.m4,v 1.5 2022/10/09 20:42:19 babolo Exp $

#connect 000_
CIPADBMS CIPALITEVAR/CIPALITEDB
#connect 0002
sqlite3 CIPALITEVAR/PROTOVER.sqlite
#perform 000_
INSERT OR IGNORE INTO CINM(pnow)
 SELECT 0, CINM(pnode).CIAT(p)
  FROM CINM(pnode)
  WHERE CINM(pnode).CIAT(m) == 'PKG'
    AND CINM(pnode).CIAT(v) == 'apas'
    AND COALESCE(NOT (SELECT 1 FROM CINM(pnow) WHERE CIAT(cred) == 0 LIMIT 1), 1)
;
#perform 0002
INSERT OR REPLACE INTO SQNM(version)(SQAT(pkg), SQAT(protover), SQAT(major), SQAT(minor))
 VALUES('PKG', NULLIF('PROTOVER', ''), MAJOR, 'MINOR')
;
#
